--
-- Testbench for the simple VGA raster generator
--
-- Stephen A. Edwards, Columbia University, sedwards@cs.columbia.edu

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity lab3_vga_tb is
  
end lab3_vga_tb;

architecture tb of lab3_vga_tb is

  component vga_raster is

  port (
    reset : in std_logic;
    clk   : in std_logic;                    -- Should be 25.125 MHz

    VGA_CLK,                                 -- Clock
    VGA_HS,                                  -- H_SYNC
    VGA_VS,                                  -- V_SYNC
    VGA_BLANK,                               -- BLANK
    VGA_SYNC : out std_logic;                -- SYNC
    VGA_R,                                   -- Red[9:0]
    VGA_G,                                   -- Green[9:0]
    VGA_B : out std_logic_vector(9 downto 0) -- Blue[9:0]
  );

  end component;

  signal clk, reset : std_logic;

  signal VGA_CLK, VGA_HS, VGA_VS, VGA_BLANK, VGA_SYNC : std_logic;

  signal VGA_R, VGA_G, VGA_B : std_logic_vector(9 downto 0);

begin

  process
  begin
    loop
       clk <= '1';
       wait for 0.5 ns;
       clk <= '0';
       wait for 0.5 ns;
    end loop;
  end process;

  process
  begin
    reset <= '1';
    wait for 5 ns;
    reset <= '0';
    wait;
  end process;

  dut : vga_raster port map (
    clk => clk,
    reset => reset,
    VGA_CLK => VGA_CLK,
    VGA_HS => VGA_HS,
    VGA_VS => VGA_VS,
    VGA_BLANK => VGA_BLANK,
    VGA_SYNC => VGA_SYNC,
    VGA_R => VGA_R,
    VGA_G => VGA_G,
    VGA_B => VGA_B
  );

end tb;
